package com.persagy.dmp.alarm.controller;

import com.persagy.common.criteria.JacksonCriteria;
import com.persagy.common.web.MapResponse;
import com.persagy.common.web.PagedResponse;
import com.persagy.dmp.alarm.jms.MessageProcesser;
import com.persagy.dmp.alarm.model.AlarmCommentModel;
import com.persagy.dmp.alarm.service.AlarmCommentService;
import com.persagy.dmp.rwd.model.DmpMessage;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
@RestController
@RequestMapping("/alarm/comment")
public class AlarmCommentController {
	@Autowired
	private AlarmCommentService service;
	@Autowired
	private MessageProcesser messageProcesser;
	
	@PostMapping("/query")
	public PagedResponse<AlarmCommentModel> query(@RequestBody JacksonCriteria criteria) {
		return service.query(criteria);
	}
	
	@PostMapping("/create")
	public MapResponse create(@RequestBody AlarmCommentModel param){
		return service.create(param);
	}
	
	@PostMapping("/sendMessage")
	public MapResponse update(@RequestBody AlarmCommentModel param){
		for (int i = 0; i < 2000; i++) {
			DmpMessage dmpMessage = new DmpMessage();
			dmpMessage.setMid(String.valueOf(i));
			dmpMessage.setType("sleep");
			messageProcesser.convertAndSend(dmpMessage);
		}
		return new MapResponse();
	}
//
//	@PostMapping("/delete")
//	public MapResponse delete(@RequestBody AlarmCommentModel param){
//		return service.delete(param);
//	}
	
}
