package com.persagy.dmp.rwd.model;

import com.fasterxml.jackson.databind.node.ArrayNode;
import com.persagy.dmp.rwd.enums.FuncidCategory;
import com.persagy.dmp.rwd.enums.FuncidDataType;
import lombok.Getter;
import lombok.Setter;

import java.util.Date;

@Setter
@Getter
public class FuncidDefModel {

    private String id;
    private String code;
    private String origCode;
    private String name;
    private String aliasCode;
    private String aliasName;
    private String classCode;
    private FuncidCategory category;
    private String type;
    private String groupCode;
    private String projectId;
    private String firstTag;
    private String secondTag;
    private String priority;
    private String inputMode;
    private String unit;
    private FuncidDataType dataType;
    private String origDataType;
    private Boolean isMultiple;
    private Boolean isRegion;
    private String formater;
    private ArrayNode dataSource;
    private String note;
    private Boolean subFlag;
    private Boolean weakPoint;
    /**通用信息点标记,1-通用信息点,2-个性化信息点*/
    private String shareType;
    /**逻辑排序序号*/
    private Integer orderSeq;

    private Integer isUsed;//状态 0.历史版本 1.使用中
    private String version;//版本
    private Date lastUpdateTime;//最后更新时间

}
